<?php

require __DIR__ . "/../vendor/autoload.php";
require __DIR__ . "/autoloader.php";
require __DIR__ . "/../vendor/zeedhi/framework/bootstrap.php";
require __DIR__ . "/../vendor/teknisa/libraries-next/scripts/bootstrap.php";

// Load specified services and parameters
$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$routes[] = __DIR__ . '/../vendor/teknisa/libraries-next/libRoutes.json';
$routes[] = __DIR__ . '/../config/routes.json';

$instanceManager->loadFromFile(__DIR__.'/../config/environment.xml');
$instanceManager->loadFromFile(__DIR__.'/../config/db.xml');
$instanceManager->loadFromFile(__DIR__.'/../config/general.xml');
$instanceManager->loadFromFile(__DIR__.'/../config/parameters.xml');
$instanceManager->loadFromFile(__DIR__.'/../vendor/zeedhi/devops_entities/environment.xml');
$container = $instanceManager->getContainer();

$instanceManager->loadFromFile(__DIR__.'/../config/doctrineEvents.xml');
$instanceManager->loadFromFile('../config/di_maps/others.xml');
$instanceManager->loadFromFile('../config/di_maps/controllers.xml');
$instanceManager->loadFromFile('../config/di_maps/services.xml');
$instanceManager->loadFromFile('../config/di_maps/factories.xml');
$instanceManager->loadFromFile('../config/di_maps/repositories.xml');

$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));
$instanceManager->compile();
