/* Sistemas Integrados TECNISA
   Servios

Nome: CALCULA_DATAS_TAREFA

Descrio:
Clculo das datas e horas previstas para incio e concluso da tarefa.

P_CDFILIAL   - Cdigo da Filial
P_CDOPERRESP - Cdigo do OPERDAOR
P_DTHRREFE   - Data/hora de referncia
P_QTHORAS    - Quantidade de horas
P_DTHRINICIO - Data/hora de incio (recebe o valor a retornar)
P_DTHRFINAL  - Data/hora de fim (recebe o valor a retornar)

Para aplicar e debugar
-- @H:\SISTEMAS\DBA\SQL\ORACLE\7199_SRVSTP_CALCULA_DATAS_TAREFA.SQL
-- EXECUTE CALCULA_DATAS_TAREFA('9999', '01', '0000000367', TO_DATE('19991213 0759', 'YYYYMMDD HH24MI'), 10, '13/12/99', '13/12/99')
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
11/12/99 - Ederson

*/

CREATE OR REPLACE
PROCEDURE CALCULA_DATAS_TAREFA
  (P_CDFILIAL   IN VARCHAR2,
   P_CDOPERRESP IN VARCHAR2,
   P_DTHRREFE   IN DATE,
   P_QTHORAS    IN NUMBER,
   P_DTHRINICIO IN OUT DATE,
   P_DTHRFINAL  IN OUT DATE) IS

   V_DTHRENTR1   DATE;
   V_DTHRSAID1   DATE;
   V_DTHRENTR2   DATE;
   V_DTHRSAID2   DATE;

   V_NRCOUNT     NUMBER;

   V_NRDIAS      NUMBER;
   V_QTDIASSOBRA NUMBER;
   V_QTMINSOBRA  NUMBER;

   V_ACHOU       NUMBER(1);

BEGIN
   P_DTHRINICIO := P_DTHRREFE;

   V_NRDIAS      := TRUNC(P_QTHORAS / 8.65, 0); /* Nmero inteiro de dias     */
   V_QTDIASSOBRA := MOD(P_QTHORAS, 8.65) / 24;  /* Nmero de dias de sobra    */

   P_DTHRFINAL := P_DTHRREFE;

   /* Soma o nmero inteiro de dias (8.65hrs) ------------------------------- */

   FOR V_NRCOUNT IN 1..V_NRDIAS LOOP
      P_DTHRFINAL := P_DTHRFINAL + 1;
      LOOP
         SELECT
            COUNT(*)
         INTO
            V_ACHOU
         FROM
            FERIFILI
         WHERE
            (CDFILIAL   = P_CDFILIAL) AND
            (DTFERIFILI = TO_DATE(TO_CHAR(P_DTHRFINAL, 'YYYYMMDD'), 'YYYYMMDD'));
         IF V_ACHOU = 1 THEN
            /* Verifica se  feriado */
            P_DTHRFINAL := P_DTHRFINAL + 1;
         ELSE
            EXIT;
         END IF;
      END LOOP;
   END LOOP;

   /* Soma o nmero de minutos restantes de acordo com o horrio base e
        verificando tambm se  feriado                                       */

   V_DTHRENTR1 := TO_DATE(TO_CHAR(P_DTHRFINAL, 'YYYYMMDD ')||'0800', 'YYYYMMDD HH24MI');
   V_DTHRSAID1 := TO_DATE(TO_CHAR(P_DTHRFINAL, 'YYYYMMDD ')||'1200', 'YYYYMMDD HH24MI');
   V_DTHRENTR2 := TO_DATE(TO_CHAR(P_DTHRFINAL, 'YYYYMMDD ')||'1321', 'YYYYMMDD HH24MI');
   V_DTHRSAID2 := TO_DATE(TO_CHAR(P_DTHRFINAL, 'YYYYMMDD ')||'1800', 'YYYYMMDD HH24MI');

   V_QTMINSOBRA := TRUNC(V_QTDIASSOBRA * 1440, 0);

   FOR V_NRCOUNT IN 1..V_QTMINSOBRA LOOP
      P_DTHRFINAL := P_DTHRFINAL + 0.0006944444;
      P_DTHRFINAL := AJUSTA_EXPEDIENTE(P_CDFILIAL,
                                       P_CDOPERRESP,
                                       P_DTHRFINAL,
                                       'NAO_CONSIDERA_LIMITE');
      LOOP
         SELECT
            COUNT(*)
         INTO
            V_ACHOU
         FROM
            FERIFILI
         WHERE
            (CDFILIAL   = P_CDFILIAL) AND
            (DTFERIFILI = TO_DATE(TO_CHAR(P_DTHRFINAL, 'YYYYMMDD'), 'YYYYMMDD'));
         IF V_ACHOU = 1 THEN
            P_DTHRFINAL := P_DTHRFINAL + 1;
         ELSE
            EXIT;
         END IF;
      END LOOP;
   END LOOP;

   IF P_DTHRFINAL < TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD HH24MI'), 'YYYYMMDD HH24MI') THEN
      P_DTHRFINAL := TO_DATE(TO_CHAR(SYSDATE, 'YYYYMMDD HH24MI'), 'YYYYMMDD HH24MI');
      P_DTHRFINAL := AJUSTA_EXPEDIENTE(P_CDFILIAL,
                                       P_CDOPERRESP,
                                       P_DTHRFINAL,
                                       'CONSIDERA_LIMITE');
   END IF;
END;
/
