import { InstanceService } from '@/services/InstanceService';
import Store from '@/store';
import { TekRestDatasource } from '@zeedhi/teknisa-components-common';

export class DMAddCallController {
	private typeIsI = false;

	private typeIsS = false;

	private typeIsEmpty = true;

	private userAuth: any;

	private PRODUCT_CODE: string = '';

	private SGSISTEMA: string = '';

	public onChangeProductAddCallModal(params: any) {
		if (params.value) {
			this.PRODUCT_CODE = params.component.value;
			if (params.component.selectValue.PLATAFORMA === 'MOBILE') {
				this.typeIsI = true;
				this.typeIsS = false;
				this.typeIsEmpty = false;
				const screenNameAddI = InstanceService.getInstanceSelectTree('screenNameAddI');
				const addCallFormInstance = InstanceService.getInstanceZdForm('formAddCallI');
				const productAddI = InstanceService.getInstanceZdSelect('productAddI');
				addCallFormInstance.value.productCodeAddI = this.PRODUCT_CODE;
				productAddI.setValue(this.PRODUCT_CODE);
				screenNameAddI.nodes = [];
				if (screenNameAddI.datasource instanceof TekRestDatasource && screenNameAddI.datasource.filter.CDCLIENTE) {
					screenNameAddI.datasource.get();
				}
			} else {
				this.SGSISTEMA = params.component.selectedData.SGSISTEMA;
				this.typeIsI = false;
				this.typeIsS = true;
				this.typeIsEmpty = false;
				const productTypeAddS = InstanceService.getInstanceZdSelect('productTypeAddS');
				productTypeAddS.datasource.get();
			}
		} else {
			this.typeIsI = false;
			this.typeIsS = false;
			this.typeIsEmpty = true;
		}
	}

	public async onMountedFormAddCall() {
		const reportedByAddField = InstanceService.getInstanceZdTextInput('reportedByAddE');
		this.userAuth = Store.getters['User/getUser'];
		reportedByAddField.value = this.userAuth.USER_NAME;
		this.typeIsI = false;
		this.typeIsS = false;
		this.typeIsEmpty = true;
	}

	public async onMountedFormAddCallI() {
		const reportedByAddField = InstanceService.getInstanceZdSelect('reportedByAddI');
		await reportedByAddField.setValue(this.userAuth.CDOPERADOR, false);
	}

	public async onMountedFormAddCallS() {
		const reportedByAddField = InstanceService.getInstanceZdSelect('reportedByAddS');
		await reportedByAddField.setValue(this.userAuth.CDOPERADOR, false);
	}
}
